#include "BinSolver.h"
#include "global.h"
#include "model.h"


#include<stdio.h>
#include<string.h>

/*  solvers=["kcnfs04SAT07", "march_dl2004", "minisat20SAT07", "rsat20", "vallst", "
zchaff_rand", "tts", "picosat846", "mxc08", "march_pl", "ranov", "adaptg2wsat0",
 "adaptg2wsatplus", "gnoveltyplus", "SATenstein_hgen", "SATenstein_r3sat", "SATe
nstein_qcp", "SATenstein_swgcp"]
*/


BinSolver* binSolvers[16];
BinSolver* LSSolver;
int NUM_ALGS = 13;

void ClearSolvers() {
	for(int i=0; i<16; i++)
	{
		printf("Clearing %dth solver\n", i);
		delete binSolvers[i];
	}

	printf("clear lsssolver\n");
	delete LSSolver;
}

void BuildSolvers(char* strseed, char* outfile)
{
   // kcnfs04SAT07
  printf("c SATzilla is building models for class %d\n", modelclass);
  binSolvers[0]=new BinSolver ("kcnfs04SAT07", 2, 1);
  binSolvers[0]->argv[2] = NULL;

  binSolvers[0]->models = new SATmodel(kcnfs04SAT07Model, kcnfs04SAT07FeatMean, kcnfs04SAT07FeatStd, kcnfs04SAT07FeatID1, kcnfs04SAT07FeatID2, kcnfs04SAT07NumFeat);
  
// march_dl2004
  binSolvers[1]=new BinSolver ("march_dl2004", 2, 1);
  binSolvers[1]->argv[2] = NULL;

binSolvers[1]->models = new SATmodel(march_dl2004Model, march_dl2004FeatMean, march_dl2004FeatStd, march_dl2004FeatID1, march_dl2004FeatID2, march_dl2004NumFeat);
  
 
// minisat20SAT07
  binSolvers[2]=new BinSolver ("minisat20SAT07", 2, 1);
  binSolvers[2]->argv[2] = NULL;

 binSolvers[2]->models = new SATmodel(minisat20SAT07Model, minisat20SAT07FeatMean, minisat20SAT07FeatStd, minisat20SAT07FeatID1, minisat20SAT07FeatID2, minisat20SAT07NumFeat);
 
// minisat20SAT07
  binSolvers[3]=new BinSolver ("minisat20", 3, 1);
  binSolvers[3]->argv[2] = "foo";
  binSolvers[3]->argv[3] = NULL;

 binSolvers[3]->models = new SATmodel(minisat20Model, minisat20FeatMean, minisat20FeatStd, minisat20FeatID1, minisat20FeatID2, minisat20NumFeat);
 
 
//rsat20
/*
 binSolvers[4]=new BinSolver ("rsat20", 3, 1);
 binSolvers[4]->argv[2] = "-s";
 binSolvers[4]->argv[3] = NULL;
binSolvers[4]->models = new SATmodel(rsat20Model, rsat20FeatMean, rsat20FeatStd, rsat20FeatID1, rsat20FeatID2, rsat20NumFeat);
 */

//vallst
 binSolvers[4]=new BinSolver ("vallst", 4, 1);
 binSolvers[4]->argv[2] = "-o";
 binSolvers[4]->argv[3] = "-";
 binSolvers[4]->argv[4] = NULL;

  binSolvers[4]->models = new SATmodel(vallstModel, vallstFeatMean, vallstFeatStd, vallstFeatID1, vallstFeatID2, vallstNumFeat);


// -- zchaff_rand
  binSolvers[5]=new BinSolver ("zchaff_rand", 3, 1);
  binSolvers[5]->argv[2] = strseed;
  binSolvers[5]->argv[3] = NULL;

binSolvers[5]->models = new SATmodel(zchaff_randModel, zchaff_randFeatMean, zchaff_randFeatStd, zchaff_randFeatID1, zchaff_randFeatID2, zchaff_randNumFeat);
 
  // -- tts
  binSolvers[6]=new BinSolver ("tts-4-0", 2, 1);
  binSolvers[6]->argv[2] = NULL;
binSolvers[6]->models = new SATmodel(ttsModel, ttsFeatMean, ttsFeatStd, ttsFeatID1, ttsFeatID2, ttsNumFeat);
 

  // -- picosat846
  binSolvers[7]=new BinSolver ("picosat846", 2, 1);
  binSolvers[7]->argv[2] = NULL;

  binSolvers[7]->models = new SATmodel(picosat846Model, picosat846FeatMean, picosat846FeatStd, picosat846FeatID1, picosat846FeatID2, picosat846NumFeat);


  // -- mxc08
  binSolvers[8]=new BinSolver ("mxc-sr08", 3, 1);
  binSolvers[8]->argv[2]="-i";
  binSolvers[8]->argv[3] = NULL;

binSolvers[8]->models = new SATmodel(mxc08Model, mxc08FeatMean, mxc08FeatStd, mxc08FeatID1, mxc08FeatID2, mxc08NumFeat);
 
/*
  // -- march_pl
  binSolvers[10]=new BinSolver ("march_pl", 2, 1);
  binSolvers[10]->argv[2] = NULL;

  binSolvers[10]->models = new SATmodel(march_plModel, march_plFeatMean, march_plFeatStd, march_plFeatID1, march_plFeatID2, march_plNumFeat);
  
  // -- ranov
  binSolvers[11]=new BinSolver ("ranov", 3, 1);
  binSolvers[11]->argv[2] = strseed;
  binSolvers[11]->argv[3] = NULL;

  binSolvers[11]->models = new SATmodel(ranovModel, ranovFeatMean, ranovFeatStd, ranovFeatID1, ranovFeatID2, ranovNumFeat);
 */
  // -- adaptg2wsat0
  binSolvers[9]=new BinSolver ("adaptg2wsat0", 3, 1);
  binSolvers[9]->argv[2] = strseed;
  binSolvers[9]->argv[3] = NULL;

 binSolvers[9]->models = new SATmodel(adaptg2wsat0Model, adaptg2wsat0FeatMean, adaptg2wsat0FeatStd, adaptg2wsat0FeatID1, adaptg2wsat0FeatID2, adaptg2wsat0NumFeat);
 

  // -- adaptg2wsat+
  binSolvers[10]=new BinSolver ("adaptg2wsat+", 3, 1);
  binSolvers[10]->argv[2] = strseed;
  binSolvers[10]->argv[3] = NULL;

binSolvers[10]->models = new SATmodel(adaptg2wsatplusModel, adaptg2wsatplusFeatMean, adaptg2wsatplusFeatStd, adaptg2wsatplusFeatID1, adaptg2wsatplusFeatID2, adaptg2wsatplusNumFeat);


  // -- gnoveltyplus
  binSolvers[11]=new BinSolver ("gnovelty+", 3, 1);
  binSolvers[11]->argv[2] = strseed;
  binSolvers[11]->argv[3] = NULL;

 binSolvers[11]->models = new SATmodel(gnoveltyplusModel, gnoveltyplusFeatMean, gnoveltyplusFeatStd, gnoveltyplusFeatID1, gnoveltyplusFeatID2, gnoveltyplusNumFeat);
 
/*
// SATenstein hgen
  binSolvers[15]=new BinSolver ("SATenstein", 37, 2);
  binSolvers[15]->argv[1] = "-inst";
  binSolvers[15]->argv[3] = "-alg";
  binSolvers[15]->argv[4] = "satenstein";
  binSolvers[15]->argv[5] = "-adaptwalkprob";
  binSolvers[15]->argv[6] = "0";
  binSolvers[15]->argv[7] = "-theta";
  binSolvers[15]->argv[8] = "3";
  binSolvers[15]->argv[9] = "-singleclause";
  binSolvers[15]->argv[10] = "1";
  binSolvers[15]->argv[11] = "-randomwalk";
  binSolvers[15]->argv[12] = "3";
  binSolvers[15]->argv[13] = "-performrandomwalk";
  binSolvers[15]->argv[14] = "1";
  binSolvers[15]->argv[15] = "-selectclause";
  binSolvers[15]->argv[16] = "1";
  binSolvers[15]->argv[17] = "-promisinglist";
  binSolvers[15]->argv[18] = "0";
  binSolvers[15]->argv[19] = "-adaptiveprom";
  binSolvers[15]->argv[20] = "0";
  binSolvers[15]->argv[21] = "-heuristic";
  binSolvers[15]->argv[22] = "7";
  binSolvers[15]->argv[23] = "-adaptive";
  binSolvers[15]->argv[24] = "1";
  binSolvers[15]->argv[25]= "-phi";
  binSolvers[15]->argv[26]= "10";
  binSolvers[15]->argv[27] ="-tabusearch";
  binSolvers[15]->argv[28]= "0";
  binSolvers[15]->argv[29] = "-rdp";
  binSolvers[15]->argv[30] = "0.15";
  binSolvers[15]->argv[31] = "-cutoff";
  binSolvers[15]->argv[32] = "4294967295";
  binSolvers[15]->argv[33] = "-seed";
  binSolvers[15]->argv[34] = strseed;
  binSolvers[15]->argv[35] = "-r";
  binSolvers[15]->argv[36] = "satcomp";
  binSolvers[15]->argv[37] = NULL;  

binSolvers[15]->models = new SATmodel(SATenstein_hgenModel, SATenstein_hgenFeatMean, SATenstein_hgenFeatStd, SATenstein_hgenFeatID1, SATenstein_hgenFeatID2, SATenstein_hgenNumFeat);
 */

// SATenstein qcp
  binSolvers[12]=new BinSolver ("SATenstein", 33, 2);
  binSolvers[12]->argv[1] = "-inst";
  binSolvers[12]->argv[3] = "-alg";
  binSolvers[12]->argv[4] = "satenstein";
  binSolvers[12]->argv[5] = "-singleclause";
  binSolvers[12]->argv[6] = "1";
  binSolvers[12]->argv[7] = "-randomwalk";
  binSolvers[12]->argv[8] = "4";
  binSolvers[12]->argv[9] = "-performrandomwalk";
  binSolvers[12]->argv[10] = "1";
  binSolvers[12]->argv[11] = "-heuristic";
  binSolvers[12]->argv[12] = "5";
  binSolvers[12]->argv[13] = "-clausepen";
  binSolvers[12]->argv[14] = "0";
  binSolvers[12]->argv[15] = "-selectclause";
  binSolvers[12]->argv[16] = "1";
  binSolvers[12]->argv[17] = "-promisinglist";
  binSolvers[12]->argv[18] = "0";
  binSolvers[12]->argv[19] = "-adaptive";
  binSolvers[12]->argv[20] = "0";
  binSolvers[12]->argv[21]= "-rfp";
  binSolvers[12]->argv[22]= "0.07";
  binSolvers[12]->argv[23] ="-tabusearch";
  binSolvers[12]->argv[24]= "0";
  binSolvers[12]->argv[25] = "-scoringmeasure";
  binSolvers[12]->argv[26] = "1";
  binSolvers[12]->argv[27] = "-cutoff";
  binSolvers[12]->argv[28] = "max";
  binSolvers[12]->argv[29] = "-seed";
  binSolvers[12]->argv[30] = "0";
  binSolvers[12]->argv[31] = "-r";
  binSolvers[12]->argv[32] = "satcomp";
  binSolvers[12]->argv[33] = NULL;  
binSolvers[12]->models = new SATmodel(SATenstein_qcpModel, SATenstein_qcpFeatMean, SATenstein_qcpFeatStd, SATenstein_qcpFeatID1, SATenstein_qcpFeatID2, SATenstein_qcpNumFeat);

/*
// SATenstein swgcp
  binSolvers[17]=new BinSolver ("SATenstein", 33, 2);
  binSolvers[17]->argv[1] = "-inst";
  binSolvers[17]->argv[3] = "-alg";
  binSolvers[17]->argv[4] = "satenstein";
  binSolvers[17]->argv[5] = "-singleclause";
  binSolvers[17]->argv[6] = "1";
  binSolvers[17]->argv[7] = "-randomwalk";
  binSolvers[17]->argv[8] = "3";
  binSolvers[17]->argv[9] = "-performrandomwalk";
  binSolvers[17]->argv[10] = "1";
  binSolvers[17]->argv[11] = "-heuristic";
  binSolvers[17]->argv[12] = "1";
  binSolvers[17]->argv[13] = "-clausepen";
  binSolvers[17]->argv[14] = "0";
  binSolvers[17]->argv[15] = "-selectclause";
  binSolvers[17]->argv[16] = "1";
  binSolvers[17]->argv[17] = "-promisinglist";
  binSolvers[17]->argv[18] = "0";
  binSolvers[17]->argv[19] = "-adaptive";
  binSolvers[17]->argv[20] = "0";
  binSolvers[17]->argv[21]= "-tabusearch";
  binSolvers[17]->argv[22]= "0";
  binSolvers[17]->argv[23] ="-rdp";
  binSolvers[17]->argv[24]= "0.01";
  binSolvers[17]->argv[25] = "-novnoise";
  binSolvers[17]->argv[26] = "0.1";
  binSolvers[17]->argv[27] = "-cutoff";
  binSolvers[17]->argv[28] = "4294967295";
  binSolvers[17]->argv[29] = "-seed";
  binSolvers[17]->argv[30] = strseed;
  binSolvers[17]->argv[31] = "-r";
  binSolvers[17]->argv[32] = "satcomp";
  binSolvers[17]->argv[33] = NULL;  
binSolvers[17]->models = new SATmodel(SATenstein_swgcpModel, SATenstein_swgcpFeatMean, SATenstein_swgcpFeatStd, SATenstein_swgcpFeatID1, SATenstein_swgcpFeatID2, SATenstein_swgcpNumFeat);
 

// SATenstein r3sat
  binSolvers[18]=new BinSolver ("SATenstein", 35, 2);
  binSolvers[18]->argv[1] = "-inst";
  binSolvers[18]->argv[3] = "-alg";
  binSolvers[18]->argv[4] = "satenstein";
  binSolvers[18]->argv[5] = "-singleclause";
  binSolvers[18]->argv[6] = "0";
  binSolvers[18]->argv[7] = "-alpha";
  binSolvers[18]->argv[8] = "1.126";
  binSolvers[18]->argv[9] = "-wp";
  binSolvers[18]->argv[10] = "0.04";
  binSolvers[18]->argv[11] = "-smoothingscheme";
  binSolvers[18]->argv[12] = "1";
  binSolvers[18]->argv[13] = "-rho";
  binSolvers[18]->argv[14] = "0.17";
  binSolvers[18]->argv[15] = "-clausepen";
  binSolvers[18]->argv[16] = "1";
  binSolvers[18]->argv[17] = "-selectclause";
  binSolvers[18]->argv[18] = "1";
  binSolvers[18]->argv[19] = "-promisinglist";
  binSolvers[18]->argv[20] = "0";
  binSolvers[18]->argv[21] = "-adaptive";
  binSolvers[18]->argv[22] = "1";
  binSolvers[18]->argv[23] = "-tiebreaking";
  binSolvers[18]->argv[24] = "2";
  binSolvers[18]->argv[25]= "-tabusearch";
  binSolvers[18]->argv[26]= "0";
  binSolvers[18]->argv[27] ="-scoringmeasure";
  binSolvers[18]->argv[28]= "1";
  binSolvers[18]->argv[29] = "-cutoff";
  binSolvers[18]->argv[30] = "4294967295";
  binSolvers[18]->argv[31] = "-seed";
  binSolvers[18]->argv[32] = strseed;
  binSolvers[18]->argv[33] = "-r";
  binSolvers[18]->argv[34] = "satcomp";
  binSolvers[18]->argv[35] = NULL;  
  binSolvers[18]->models = new SATmodel(SATenstein_r3satModel, SATenstein_r3satFeatMean, SATenstein_r3satFeatStd, SATenstein_r3satFeatID1, SATenstein_r3satFeatID2, SATenstein_r3satNumFeat);
*/


  binSolvers[13]=new BinSolver ("SATenstein", 77, 2);
  binSolvers[13]->argv[1] = "-inst";
  binSolvers[13]->argv[3] = "-alg";
  binSolvers[13]->argv[4] = "satenstein";
  binSolvers[13]->argv[5] = "-tabu";
  binSolvers[13]->argv[6] = "1";
  binSolvers[13]->argv[7] = "-rwp";
  binSolvers[13]->argv[8] = "0.01";
  binSolvers[13]->argv[9] = "-adaptwalkprob";
  binSolvers[13]->argv[10] = "1";
  binSolvers[13]->argv[11] = "-adaptpromwalkprob";
  binSolvers[13]->argv[12] = "1";
  binSolvers[13]->argv[13] = "-theta";
  binSolvers[13]->argv[14] = "8";
  binSolvers[13]->argv[15] = "-singleclause";
  binSolvers[13]->argv[16] = "1";
  binSolvers[13]->argv[17] = "-randomwalk";
  binSolvers[13]->argv[18] = "1";
  binSolvers[13]->argv[19] = "-promdp";
  binSolvers[13]->argv[20] = "0.07";
  binSolvers[13]->argv[21] = "-performalternatenovelty";
  binSolvers[13]->argv[22] = "1";
  binSolvers[13]->argv[23] = "-dp";
  binSolvers[13]->argv[24] = "0.01";
  binSolvers[13]->argv[25]= "-performrandomwalk";
  binSolvers[13]->argv[26]= "1";
  binSolvers[13]->argv[27] ="-promwp";
  binSolvers[13]->argv[28]= "0.05";
  binSolvers[13]->argv[29] = "-heuristic";
  binSolvers[13]->argv[30] = "1";
  binSolvers[13]->argv[31] = "-clausepen";
  binSolvers[13]->argv[32] = "0";
  binSolvers[13]->argv[33] = "-c";
  binSolvers[13]->argv[34] = "0.00001";
  binSolvers[13]->argv[35] = "-selectclause";
  binSolvers[13]->argv[36] = "1";
  binSolvers[13]->argv[37] = "-promisinglist";
  binSolvers[13]->argv[38] = "1";
  binSolvers[13]->argv[39] = "-adaptiveprom";
  binSolvers[13]->argv[40] = "1";
  binSolvers[13]->argv[41] = "-adaptive";
  binSolvers[13]->argv[42] = "0";
  binSolvers[13]->argv[43] = "-varinfalse";
  binSolvers[13]->argv[44] = "1";
  binSolvers[13]->argv[45] = "-updateschemepromlist";
  binSolvers[13]->argv[46] = "1";
  binSolvers[13]->argv[47]= "-decreasingvariable";
  binSolvers[13]->argv[48]= "10";
  binSolvers[13]->argv[49] ="-wpwalk";
  binSolvers[13]->argv[50]= "0.7";
  binSolvers[13]->argv[51] = "-promphi";
  binSolvers[13]->argv[52] = "3";
  binSolvers[13]->argv[53]= "-phi";
  binSolvers[13]->argv[54]= "7";
  binSolvers[13]->argv[55] ="-tiebreaking";
  binSolvers[13]->argv[56]= "4";
  binSolvers[13]->argv[57] = "-tabusearch";
  binSolvers[13]->argv[58] = "1";
  binSolvers[13]->argv[59] = "-scoringmeasure";
  binSolvers[13]->argv[60] = "1";
  binSolvers[13]->argv[61] = "-s";
  binSolvers[13]->argv[62] = "0.01";
  binSolvers[13]->argv[63] = "-promtheta";
  binSolvers[13]->argv[64] = "3";
  binSolvers[13]->argv[65]= "-promnovnoise";
  binSolvers[13]->argv[66]= "0.8";
  binSolvers[13]->argv[67] ="-novnoise";
  binSolvers[13]->argv[68]= "0.4";
  binSolvers[13]->argv[69] = "-adaptivenoisescheme";
  binSolvers[13]->argv[70] = "2";
  binSolvers[13]->argv[71] = "-cutoff";
  binSolvers[13]->argv[72] = "max";
  binSolvers[13]->argv[73] = "-seed";
  binSolvers[13]->argv[74] = "0";
  binSolvers[13]->argv[75] = "-r";
  binSolvers[13]->argv[76] = "satcomp";
  binSolvers[13]->argv[77] = NULL;  


 // -- zchaff07 for compute features
  binSolvers[14]=new BinSolver ("zchaff07", 2, 1);
  binSolvers[14]->argv[2] = NULL;


  binSolvers[15]=new BinSolver ("satelite", 3, 1);
  binSolvers[15]->argv[2] = outfile;
  binSolvers[15]->argv[3] = NULL;

 

  LSSolver=new BinSolver ("ubcsat2006", 17, 2);
  LSSolver->argv[1] = "-inst";
  LSSolver->argv[3] = "-alg";
  LSSolver->argv[4] = "saps";
  LSSolver->argv[5] = "-alpha";
  LSSolver->argv[6] = "1.3";
  LSSolver->argv[7] = "-rho";
  LSSolver->argv[8] = "0.1";
  LSSolver->argv[9] = "-cutoff";
  LSSolver->argv[10] = "max";
  LSSolver->argv[11] = "-timeout";
  LSSolver->argv[12] = LS_PREP_TIMEOUT;
//  LSSolver->argv[13] = "-solve";
  LSSolver->argv[13] = "-seed";
  LSSolver->argv[14] = strseed;
  LSSolver->argv[15] = "-r";
  LSSolver->argv[16] = "satcomp";
  LSSolver->argv[17] = NULL;  
 

}
int runLocalSearch(char* inputFile, char* strseed)
{
  char* argv[] = {"ubcsat",
                  "-alg", "saps",  "-i", inputFile, "-runs", "1",
                  "-alpha", "1.3", "-rho", "0.1",  "-timeout", LS_PREP_TIMEOUT,
                  "-seed", strseed,
                  "-solve"};
  //		  "-r", "satcomp", vlineFilename,

  int argc = 16;

  printf("c satzilla is running local search for 30s\n");
  return  ubcsat::main(argc, argv);

}
