#include "SATmodel.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <math.h>


// NOTE: coeffs is the array of numFeat coefficients.  coeffs[numFeat] is the constant term.

SATmodel::SATmodel(double* Coeffs, double* cMean, double* cStd, int* featureID1, int* featureID2, int numFeat) {
   numFeatures = numFeat;
   c1 = Coeffs;
   ID1 = featureID1;
   ID2 = featureID2;
   mean = cMean;
   std = cStd;
   }

double SATmodel::estimateRunTime(double *features) {
   double val1 = c1[numFeatures];
   double realFeatures;
   
   for (int i=0; i<numFeatures; i++){
         int m = ID1[i];
         int n = ID2[i];
	 double x;
	 double y;
         if (m==0) 
		x = 1;
         else
		 x = features[m-1];
 	 
         if (n==0) 
		y = 1;
         else
		y = features[n-1];
         double tmpFeat = (x*y-mean[i])/std[i];
        
       val1 += c1[i] * tmpFeat;
   }
   return val1;
}
