/*

      ##  ##  #####    #####   $$$$$   $$$$   $$$$$$    
      ##  ##  ##  ##  ##      $$      $$  $$    $$      
      ##  ##  #####   ##       $$$$   $$$$$$    $$      
      ##  ##  ##  ##  ##          $$  $$  $$    $$      
       ####   #####    #####  $$$$$   $$  $$    $$      
  ======================================================
  SLS SAT Solver from The University of British Columbia
  ======================================================
  ...Developed by Dave Tompkins (davet [@] cs.ubc.ca)...
  ------------------------------------------------------
  .......consult legal.txt for legal information........
  ......consult revisions.txt for revision history......
  ------------------------------------------------------
  ... project website: http://www.satlib.org/ubcsat ....
  ------------------------------------------------------
  .....e-mail ubcsat-help [@] cs.ubc.ca for support.....
  ------------------------------------------------------

*/

#ifndef UBCSAT

#define UBCSAT

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "ubcsat-limits.h"
#include "ubcsat-types.h"

#include "ubcsat-lit.h"
#include "ubcsat-mem.h"
#include "ubcsat-time.h"
#include "ubcsat-io.h"
#include "ubcsat-internal.h"
#include "ubcsat-globals.h"
#include "ubcsat-triggers.h"

#include "algorithms.h"
#include "reports.h"

#include "mylocal.h"

#endif

